
function units_antiair_alien_shieldUp(unit)
	unit:play3DSound("antiair alien shield up.wav",0)
	unit:addAnimationToQueue(ENAT_IDLETIMEOUT1,1)
	while unit:getCurrentAnimation() ~= ENAT_IDLE do
		pause()
	end
	unit:play3DSound("antiair alien field 0.wav",0)
	unit:getBone(ENBT_FAN,0):addRotationEffect(ENET_EFFECT_ROTATE_RADAR,MATH_PI / 4)
	unit:getBone(ENBT_FAN,0):addSimpleEffect(ENET_EFFECT_GEOMETRY_AA_ALIEN_KUPOL)
end

function units_antiair_alien_shieldDown(unit)
	unit:play3DSound("antiair alien shield down.wav",0)
	unit:addAnimationToQueue(ENAT_IDLETIMEOUT2,1)
	local shieldBone = unit:getBone(ENBT_FAN,0)
	shieldBone:killEffect(ENET_EFFECT_ROTATE_RADAR)
	shieldBone:killEffect(ENET_EFFECT_GEOMETRY_AA_ALIEN_KUPOL)
end

function units_antiair_alien_setup()
	local unit = uniGetExecutor()
	unit:resetAnimations()
	local owner = uniGetTarget()
	if(owner) then
		unit:setTransformOwner(units_findfreefirespot(owner,1))
		unit:setLocalPosition(0,0,0)
		unit:setLocalOrientation(0,1,0,0,0,1)
		if(owner:getIsPlacesVisible() == false) then
			unit:setVisibility(false,false)
		end
	end
	if owner ~= nil then
		if owner:getIsPlacesVisible() then owner = nil end
	end
	if owner == nil then units_antiair_alien_shieldUp(unit) end
	units_setup(3,true,nil,ENET_EFFECT_GEOMETRY_ANTIAIRALIEN_SHADOW,true,false)
--[[
	local unit = uniGetExecutor()
	unit:play3DSound("setup.wav",0)
	if uniGetTarget() == nil then units_antiair_alien_shieldUp(unit) end
	units_setup(3,true,nil,ENET_EFFECT_GEOMETRY_ANTIAIRALIEN_SHADOW,true,false)
]]--
end

function units_antiair_alien_resetup()
	local unit = uniGetExecutor()
	unit:resetAnimations()
	local owner = uniGetTarget()
	if(owner) then
		unit:setTransformOwner(units_findfreefirespot(owner,1))
		unit:setLocalPosition(0,0,0)
		unit:setLocalOrientation(0,1,0,0,0,1)
		if(owner:getIsPlacesVisible() == false) then
			unit:setVisibility(false,false)
		end
	end
	if owner ~= nil then
		if owner:getIsPlacesVisible() then owner = nil end
	end
	if owner == nil then units_antiair_alien_shieldUp(unit) end
	units_setup(3,true,nil,ENET_EFFECT_GEOMETRY_ANTIAIRALIEN_SHADOW,true,false)
--[[
	uniGetExecutor():resetAnimations()
	if uniGetTarget() == nil then units_antiair_alien_shieldUp(uniGetExecutor()) end
	units_setup(3,true,nil,ENET_EFFECT_GEOMETRY_ANTIAIRALIEN_SHADOW,true,false)
]]--
end

function units_antiair_alien_select()
	units_select(12,1)
end

function units_antiair_alien_unselect()
	units_unselect()
end

function units_antiair_alien_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_antiair_alien_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_antiair_alien_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_antiair_alien_explode()
	units_explode_big1()
	uniGetExecutor():getBone(ENBT_FAN,0):killEffect(ENET_EFFECT_GEOMETRY_AA_ALIEN_KUPOL)
end

function units_antiair_alien_fire()
end

function units_antiair_alien_move()
	local unit = uniGetExecutor()
	units_antiair_alien_shieldDown(unit)
	unit:addAnimationToQueue(ENAT_GO,MATH_INFINITY)
	while unit:getCurrentAnimation() ~= ENAT_GO do
		pause()
	end
	local sound = unit:play3DSound("aniair turn.wav",1)

	local steps = {}
	local i = 0;
	for i = 0,1 do
		steps[i] = unit:getBone(ENBT_STEPEMITTER,i):addSimpleEffect(ENET_EFFECT_DYNAMICGEOMETRY_LIGHTTANKSTEPSEMITTER)
		steps[i+2] = unit:getBone(ENBT_STEPEMITTER,i):addSimpleEffect(ENET_EFFECT_PS_NEWTRACKSMOKE2)
	end

	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNIT,MATH_PI * 0.45))
	sound:destroy()
	sound = unit:play3DSound("lighttank_alien_move.wav",1)
	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_LINEAR,80))
	unit:setCurrentAnimationRepeatCount(1)
	units_antiair_alien_shieldUp(unit)
	sound:destroy()

	for i = 0,1 do
		if(unit:getScale() < 1.0) then 
			steps[i]:destroy()
		else
			steps[i]:setTransformOwner()
			steps[i]:suspendedDestroy(70)
		end
		steps[i+2]:suspendedDestroy(1.0)
	end

end

-- register functions to unit scriptset - they will be called when specified command arrives to unit
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_MOVE,"units_antiair_alien_move")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_FIRE1,"units_antiair_alien_fire")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_FIRE2,"units_antiair_alien_fire")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_SELECT,"units_antiair_alien_select")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_SELECTENEMY,"units_antiair_alien_selectenemy")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_UNSELECT,"units_antiair_alien_unselect")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_SETUP,"units_antiair_alien_setup")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_RESETUP,"units_antiair_alien_resetup")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_DAMAGED,"units_antiair_alien_damaged")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_EXPLODE,"units_antiair_alien_explode")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_HIGHLIGHT,"units_antiair_alien_highlight")
registerCommand(ENSCRIPTSET_ANTIAIR_ALIEN,ENC_INSIDE,"units_inside")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_ANTIAIR_ALIEN)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "antiair_alien.rmd"
desc.ScriptSet = ENSCRIPTSET_ANTIAIR_ALIEN
desc.MoveType = ENMOVE_GROUNDORIENTED
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_ANTIAIRALIEN_SHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "antiair_alien_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(31)
unitDesc.group = 2
unitDesc.order = 5
unitDesc.unit_res_id = ENET_UNIT_ANTIAIR_ALIEN
unitDesc.unit_icon_id = "Antiair_a_small_normal.dds"
unitDesc.active_id = "Antiair_a_small_active.dds"
unitDesc.pressed_id = "Antiair_a_small_pressed.dds"
unitDesc.small_icon_id = "Antiair_l_stats.dds"
unitDesc.big_icon_id = "Antiair_a_big_normal.dds"
unitDesc.HP = 4
unitDesc.MP = 10
unitDesc.WR = 1
unitDesc.min_WR = 0
unitDesc.WD = 0
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 0
unitDesc.transport = 0
unitDesc.value = 3
unitDesc.race = 1
unitDesc.fire_pause = 0.6
unitDesc.move_pause = 0.5
unitDesc.unit_info_scale = 0.07
unitDesc.scn_name = "PTEROSHIELD"
