
function units_battleship_alien_setup()
	units_setup_sea(8,true,true,ENET_EFFECT_GEOMETRY_BATTLESHIPALIENSHADOW)
end

function units_battleship_alien_resetup()
	units_setup_sea(8,true,false,ENET_EFFECT_GEOMETRY_BATTLESHIPALIENSHADOW)
end

function units_battleship_alien_select()
	units_select(17,3)
end

function units_battleship_alien_unselect()
	units_unselect()
end

function units_battleship_alien_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_battleship_alien_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_battleship_alien_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_battleship_alien_explode()
	units_explode_water2()
end

function units_battleship_alien_move()
	local unit = uniGetExecutor()
	local sound = unit:play3DSound("battleship_alien_move.wav",1)
	local steps = unit:addSimpleEffect(ENET_EFFECT_EFFECTEMITTER_SHIP_WATERTRAY)
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNIT,MATH_PI * 0.7))
	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_LINEAR,80))
	steps:suspendedDestroy(2.0)
	sound:destroy()
	unit:play3DSound("battleship_alien_stop.wav",0):destroy()
end

function units_battleship_alien_fire()
	local unit = uniGetExecutor()
	local gt = {}
	local i
	local j
	local fireSpot
	uniSetLife(uniGetLife() / 6.0)
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNITBOARDTOTARGET,MATH_PI * 0.7,uniGetTarget()))
	unit:addAnimationToQueue(ENAT_PREPAREFORFIRE1,1)
	unit:addAnimationToQueue(ENAT_FIREPOSITION1,MATH_INFINITY)
	unit:addAnimationToQueue(ENAT_AFTERFIRE1,1)
	local sound = unit:play3DSound("battleship_alien_gun_rotate.wav",0):destroy()
	local gn = unit:getBone(ENBT_GUNNEST)
	local guns = {}
	for i = 0,1 do
		guns[i] = gn:getBone(ENBT_GUN,i)
		guns[i]:addRotationEffect(ENET_EFFECT_ROTATE_GUNTOTARGET_GRAVITYPARABOLA,MATH_PI / 3.0,uniGetTarget())
	end
	pause(1.5)
	for i = 0,1 do
		for j = 0,2 do
			guns[i]:play3DSound("battleship_alien_fire.wav",0):destroy()
			--guns[i]:getBone(ENBT_FIRE1,j):addBulletEffect(ENET_EFFECT_BULLET_PLAZMABALL):executeCommand(ENC_FIRE1)
			guns[i]:getBone(ENBT_FIRE1,j):addSimpleEffect(ENET_EFFECT_PS_NEWPLAZMABALL_FLY):executeCommand(ENC_FIRE1)
			pause(0.25)
		end
	end
	pause(1.0)
	for i = 0,1 do
		guns[i]:addRotationEffect(ENET_EFFECT_ROTATE_GUNTOWERDEFAULT,MATH_PI / 3.0)
	end
	pause(1.0)
	unit:setCurrentAnimationRepeatCount(0)
	unit:addFireArrow()
end

registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_MOVE,"units_battleship_alien_move")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_FIRE1,"units_battleship_alien_fire")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_FIRE2,"units_battleship_alien_fire")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_SELECT,"units_battleship_alien_select")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_SELECTENEMY,"units_battleship_alien_selectenemy")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_UNSELECT,"units_battleship_alien_unselect")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_SETUP,"units_battleship_alien_setup")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_RESETUP,"units_battleship_alien_resetup")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_DAMAGED,"units_battleship_alien_damaged")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_EXPLODE,"units_battleship_alien_explode")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_HIGHLIGHT,"units_battleship_alien_highlight")
registerCommand(ENSCRIPTSET_BATTLESHIP_ALIEN,ENC_INSIDE,"units_inside")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_BATTLESHIP_ALIEN)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "battleship_alien.rmd"
desc.ScriptSet = ENSCRIPTSET_BATTLESHIP_ALIEN
desc.MoveType = ENMOVE_SWIM
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_BATTLESHIPALIENSHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "battleship_alien_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(22)
unitDesc.group = 1
unitDesc.order = 3
unitDesc.unit_res_id = ENET_UNIT_BATTLESHIP_ALIEN
unitDesc.unit_icon_id = "Battleship_a_small_normal.dds"
unitDesc.active_id = "Battleship_a_small_active.dds"
unitDesc.pressed_id = "Battleship_a_small_pressed.dds"
unitDesc.small_icon_id = "Battleship_l_stats.dds"
unitDesc.big_icon_id = "Battleship_a_big_normal.dds"
unitDesc.HP = 8
unitDesc.MP = 40
unitDesc.WR = 3
unitDesc.min_WR = 1
unitDesc.WD = 3
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 3
unitDesc.transport = 0
unitDesc.value = 5
unitDesc.race = 1
unitDesc.fire_pause = 2.0
unitDesc.move_pause = 1.0
unitDesc.unit_info_scale = 0.04
unitDesc.scn_name = "BSHIPA"







