
function units_battleship_setup()
	units_setup_sea(8,false,true,ENET_EFFECT_GEOMETRY_BATTLESHIPSHADOW)
end

function units_battleship_resetup()
	units_setup_sea(8,false,false,ENET_EFFECT_GEOMETRY_BATTLESHIPSHADOW)
end

function units_battleship_select()
	units_select(17,3)
end

function units_battleship_unselect()
	units_unselect()
end

function units_battleship_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_battleship_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_battleship_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_battleship_explode()
	units_explode_water2()
end

function units_battleship_move()
	local unit = uniGetExecutor()
	local sound = unit:play3DSound("battleship_move.wav",1)
	local steps = unit:addSimpleEffect(ENET_EFFECT_EFFECTEMITTER_SHIP_WATERTRAY)
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNIT,MATH_PI * 0.7))
	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_LINEAR,80))
	steps:suspendedDestroy(2.0)
	sound:destroy()
	unit:play3DSound("battleship_stop.wav",0):destroy()
end

function units_battleship_fire()
	local unit = uniGetExecutor()
	local gt = {}
	local i
	local j
	local fireSpot

	uniSetLife(uniGetLife() / 6.0)
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNITBOARDTOTARGET,MATH_PI * 0.7,uniGetTarget()))
	if(unit:getObjectPositionInLocalSpace(uniGetTarget()).x < 0)
		then gt[0] = unit:getBone(ENBT_GUNTOWER,0)
		else gt[0] = unit:getBone(ENBT_GUNTOWER,1)
	end
	gt[1] = unit:getBone(ENBT_GUNTOWER,2)
	gt[2] = unit:getBone(ENBT_GUNTOWER,3)
	for i = 0,2 do
		gt[i]:addRotationEffect(ENET_EFFECT_ROTATE_GUNTOWERTOTARGET,MATH_PI,uniGetTarget())
	end
	pause(1.2)
	for i = 0,2 do
		unit:play3DSound("battleship_fire.wav",0):destroy()
		for j = 0,1 do
			fireSpot = gt[i]:getBone(ENBT_FIRE1, j)
			gt[i]:gunRecoil(j, 0.4, 7.0)
			fireSpot:addSimpleEffect(ENET_EFFECT_PS_BATTLESHIPSHOT):delayedDestroy(1.5)
			fireSpot:addSimpleEffect(ENET_EFFECT_LIGHT_BATTLESHIPSHOT):delayedDestroy(1.5)
			fireSpot:addBulletEffect(ENET_EFFECT_BULLET_BATTLESHIPSHOT):executeCommand(ENC_FIRE1)
			pause(0.1)
		end
	end
	pause(1.0)
	for i = 0,2 do
		gt[i]:addRotationEffect(ENET_EFFECT_ROTATE_GUNTOWERDEFAULT,MATH_PI)
	end
	unit:addFireArrow()
end

registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_MOVE,"units_battleship_move")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_FIRE1,"units_battleship_fire")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_FIRE2,"units_battleship_fire")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_SELECT,"units_battleship_select")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_SELECTENEMY,"units_battleship_selectenemy")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_UNSELECT,"units_battleship_unselect")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_SETUP,"units_battleship_setup")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_RESETUP,"units_battleship_resetup")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_DAMAGED,"units_battleship_damaged")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_EXPLODE,"units_battleship_explode")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_HIGHLIGHT,"units_battleship_highlight")
registerCommand(ENSCRIPTSET_BATTLESHIP,ENC_INSIDE,"units_inside")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_BATTLESHIP)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "battleship.rmd"
desc.ScriptSet = ENSCRIPTSET_BATTLESHIP
desc.MoveType = ENMOVE_SWIM
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_BATTLESHIPSHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "battleship_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(9)
unitDesc.group = 1
unitDesc.order = 3
unitDesc.unit_res_id = ENET_UNIT_BATTLESHIP
unitDesc.unit_icon_id = "Battleship_h_small_normal.dds"
unitDesc.active_id = "Battleship_h_small_active.dds"
unitDesc.pressed_id = "Battleship_h_small_pressed.dds"
unitDesc.big_icon_id = "Battleship_h_big_normal.dds"
unitDesc.small_icon_id = "Battleship_u_stats.dds"
unitDesc.HP = 8
unitDesc.MP = 40
unitDesc.WR = 3
unitDesc.min_WR = 1
unitDesc.WD = 3
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 3
unitDesc.transport = 0
unitDesc.value = 5
unitDesc.race = 0
unitDesc.fire_pause = 2.0
unitDesc.move_pause = 1.0
unitDesc.unit_info_scale = 0.04
unitDesc.scn_name = "BSHIP"


------------------------------------------------------------------------------------------------------
------------------------ effects related to unit------------------------------------------------------
------------------------------------------------------------------------------------------------------

function bullets_battleshipshot_fire()
	local bullet = uniGetExecutor()
	bullet:setTransformOwner()
	waitDeath(bullet:addMoveEffect(ENET_EFFECT_MOVE_LINEARFLY_RANDOMGROUNDLEVELPOSITION,2000,uniGetTarget()),50)
	local hitType = bullet:getLastMovementEndType();
	if(hitType == ENBHT_DIRECTHIT) then
		bullet:addSimpleEffect(ENET_EFFECT_PS_BATTLESHIPSHOTHIT):suspendedDestroy(2.0)
	elseif(hitType == ENBHT_GROUNDHIT) then
		bullet:addSimpleEffect(ENET_EFFECT_PS_BOMB_EARTHHIT):suspendedDestroy(2.0)
	elseif(hitType == ENBHT_WATERHIT) then
		bullet:addSimpleEffect(ENET_EFFECT_PS_BOMB_WATERHIT):suspendedDestroy(2.0)
	end
	pause(0.2)
	uniGetTarget():executeCommand(ENC_DAMAGED)
	pause(2.0)
	bullet:destroy()
end

registerCommand(ENSCRIPTSET_BULLET_BATTLESHIPSHOT,ENC_FIRE1,"bullets_battleshipshot_fire")

