
function units_bomber_alien_select()
	units_select(12)
end

function units_bomber_alien_unselect()
	units_unselect()
end

function units_bomber_alien_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_bomber_alien_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_bomber_alien_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_bomber_alien_setup()
	local bomber = uniGetExecutor()
	bomber:addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_SPOTLIGHT_RED4):setLocalPosition(-17,10,-9)
	bomber:addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_SPOTLIGHT_RED4):setLocalPosition(17,10,-9)
	
	bomber:setTransformOwner(units_findfreefirespot(uniGetTarget(),1))
	bomber:setLocalPosition(0,0,0)
	units_reloadfirespots(bomber,1,ENET_EFFECT_BULLET_BOMB)
	bomber:setVisibility(true,true)
	bomber:addSimpleEffect(ENET_EFFECT_BOUNDEDTEXT)
	bomber:addSimpleEffect(ENET_EFFECT_GEOMETRY_AIRALIENSHADOW)

end

function units_bomber_alien_fire()
	local unit = uniGetExecutor()
	local base = unit:getTransformOwner()
	local target = uniGetTarget()

	uniSetLife(uniGetLife() / 3.0)

	local holders = {}
	holders[0] = enHolder:new(target)
	holders[1] = enHolder:new(base,HT_CARGOSPACE)

	unit:setTransformOwner()

	local enginePS = {}
	enginePS[0] = unit:getBone(ENBT_STEPEMITTER,0):addSimpleEffect(ENET_EFFECT_PS_ALIENAIR_TRAY)
	enginePS[1] = unit:getBone(ENBT_STEPEMITTER,1):addSimpleEffect(ENET_EFFECT_PS_ALIENAIR_TRAY)

	local sound = unit:play3DSound("air_move.wav",1)

	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_AIRSMOOTH,100,uniGetTarget()))

	local firespot = unit:getBone(ENBT_FIRE1,0)

	local mover = unit:addMoveEffect(ENET_EFFECT_MOVE_AIRSMOOTH,100,base)
	holders[3] = enHolder:new(mover);

	firespot:findEffect(ENET_EFFECT_BULLET_BOMB):executeCommand(ENC_FIRE1)
	pause(0.2)
	firespot:addSimpleEffect(ENET_EFFECT_BULLET_BOMB):executeCommand(ENC_FIRE1)
	pause(0.2)
	firespot:addSimpleEffect(ENET_EFFECT_BULLET_BOMB):executeCommand(ENC_FIRE1)
	pause(0.2)
	firespot:addSimpleEffect(ENET_EFFECT_BULLET_BOMB)
	waitDeath(mover)

	enginePS[0]:suspendedDestroy(2.0);
	enginePS[1]:suspendedDestroy(2.0);

	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_AIRHORIZONTALORIENT,1.57))
	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_LINEARFLYTOOWNER,100,base))
	unit:setTransformOwner(base)
	sound:destroy()
	unit:addFireArrow()
end

function units_bomber_alien_move()
	local bomber = uniGetExecutor()
	bomber:setTransformOwner()

	local enginePS = {}
	enginePS[0] = bomber:getBone(ENBT_STEPEMITTER,0):addSimpleEffect(ENET_EFFECT_PS_ALIENAIR_TRAY)
	enginePS[1] = bomber:getBone(ENBT_STEPEMITTER,1):addSimpleEffect(ENET_EFFECT_PS_ALIENAIR_TRAY)

	local holder = enHolder:new(uniGetTarget())
	local base = units_findfreefirespot(uniGetTarget(),1)
	local placeHolder = enHolder:new(base,HT_CARGOSPACE)
	local sound = bomber:play3DSound("air_move.wav",1)
	waitDeath(bomber:addMoveEffect(ENET_EFFECT_MOVE_AIRSMOOTH,100,base))
	sound:destroy()
	bomber:play3DSound("air_stop.wav",0):destroy()

	enginePS[0]:suspendedDestroy(2.0);
	enginePS[1]:suspendedDestroy(2.0);

	waitDeath(bomber:addRotationEffect(ENET_EFFECT_ROTATE_AIRHORIZONTALORIENT,1.57))
	waitDeath(bomber:addMoveEffect(ENET_EFFECT_MOVE_LINEARFLYTOOWNER,100,base))
	bomber:setTransformOwner(base)
end

function units_bomber_alien_explode()
	local bomber = uniGetExecutor()
	bomber:setTransformOwner()
	bomber:play3DSound("bigunitexplode.wav",0):destroy()
	local ps_explode = bomber:addSimpleEffect(ENET_EFFECT_PS_BOMBEREXPLODE)
	ps_explode:setTransformOwner()
	pause(0.5)
	bomber:setVisibility(false,false)
	pause(0.5)
	ps_explode:suspendedDestroy(6.5)
	--pause(1.2)
end

registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_SETUP,"units_bomber_alien_setup")
registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_RESETUP,"units_bomber_alien_setup")
registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_FIRE1,"units_bomber_alien_fire")
registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_FIRE2,"units_bomber_alien_fire")
registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_MOVE,"units_bomber_alien_move")
registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_EXPLODE,"units_bomber_alien_explode")
registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_SELECT,"units_bomber_alien_select")
registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_SELECTENEMY,"units_bomber_alien_selectenemy")
registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_UNSELECT,"units_bomber_alien_unselect")
registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_DAMAGED,"units_bomber_alien_damaged")
registerCommand(ENSCRIPTSET_BULLET_AIR_ALIEN,ENC_HIGHLIGHT,"units_bomber_alien_highlight")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_AIR_ALIEN)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "air_alien.rmd"
desc.ScriptSet = ENSCRIPTSET_BULLET_AIR_ALIEN
desc.MoveType = ENMOVE_FLY
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_AIRALIENSHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "air_alien_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(24)
unitDesc.group = 2
unitDesc.order = 4
unitDesc.unit_res_id = ENET_UNIT_AIR_ALIEN
unitDesc.unit_icon_id = "Air_a_small_normal.dds"
unitDesc.active_id = "Air_a_small_active.dds"
unitDesc.pressed_id = "Air_a_small_pressed.dds"
unitDesc.small_icon_id = "Fighter_l_stats.dds"
unitDesc.big_icon_id = "Air_a_big_normal.dds"
unitDesc.HP = 1
unitDesc.MP = 120
unitDesc.WR = 6
unitDesc.min_WR = 1
unitDesc.WD = 1
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 4
unitDesc.transport = 0
unitDesc.value = 3
unitDesc.race = 1
unitDesc.fire_pause = 10.0
unitDesc.move_pause = 10.0
unitDesc.unit_info_scale = 0.10
unitDesc.scn_name = "AIRA"


