
function setup_capital()
	local unit = uniGetExecutor()
	unit:resetBones()
	unit:resetAnimations()
	unit:addSimpleEffect(ENET_EFFECT_BOUNDEDTEXT)
	if(unit:getEffectType() == ENET_UNIT_CAPITAL_LARGE) then
		unit:addSimpleEffect(ENET_GEOMETRY_CAPITAL_LARGE_SHADOW)
	elseif(unit:getEffectType() == ENET_UNIT_CAPITAL_MEDIUM) then
		unit:addSimpleEffect(ENET_GEOMETRY_CAPITAL_MEDIUM_SHADOW)
	elseif(unit:getEffectType() == ENET_UNIT_CAPITAL_SMALL) then
		unit:addSimpleEffect(ENET_GEOMETRY_CAPITAL_SMALL_SHADOW)
	end
	unit:addMaskRender(ENMAT_CAPITAL_MASK)
end

function units_capital_setup()
	setup_capital()
end

function units_capital_resetup()
	setup_capital()
end

function units_capital_select()
	units_select(0,6)
end

function units_capital_unselect()
	units_unselect()
end

function units_capital_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_capital_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_capital_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_capital_explode()
	units_explode_small()
end

function units_capital_move()
end

function units_capital_fire()
end

registerCommand(ENSCRIPTSET_CAPITAL,ENC_MOVE,"units_capital_move")
registerCommand(ENSCRIPTSET_CAPITAL,ENC_FIRE1,"units_capital_fire")
registerCommand(ENSCRIPTSET_CAPITAL,ENC_FIRE2,"units_capital_fire")
registerCommand(ENSCRIPTSET_CAPITAL,ENC_SELECT,"units_capital_select")
registerCommand(ENSCRIPTSET_CAPITAL,ENC_SELECTENEMY,"units_capital_selectenemy")
registerCommand(ENSCRIPTSET_CAPITAL,ENC_UNSELECT,"units_capital_unselect")
registerCommand(ENSCRIPTSET_CAPITAL,ENC_SETUP,"units_capital_setup")
registerCommand(ENSCRIPTSET_CAPITAL,ENC_RESETUP,"units_capital_resetup")
registerCommand(ENSCRIPTSET_CAPITAL,ENC_DAMAGED,"units_capital_damaged")
registerCommand(ENSCRIPTSET_CAPITAL,ENC_EXPLODE,"units_capital_explode")
registerCommand(ENSCRIPTSET_CAPITAL,ENC_HIGHLIGHT,"units_capital_highlight")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_CAPITAL_LARGE)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "citybottom_large.rmd"
desc.ScriptSet = ENSCRIPTSET_CAPITAL
desc.MoveType = ENMOVE_GROUND
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_CAPITAL
desc.MaterialColors = units_materialcolors_human

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_CAPITAL_MEDIUM)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "citybottom_medium.rmd"
desc.ScriptSet = ENSCRIPTSET_CAPITAL
desc.MoveType = ENMOVE_GROUND
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_CAPITAL
desc.MaterialColors = units_materialcolors_human

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_CAPITAL_SMALL)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "citybottom_small.rmd"
desc.ScriptSet = ENSCRIPTSET_CAPITAL
desc.MoveType = ENMOVE_GROUND
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_CAPITAL
desc.MaterialColors = units_materialcolors_human

-- shadow for city
desc = getEffectDescriptionP(ENET_GEOMETRY_CAPITAL_LARGE_SHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "citybottom_large_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- shadow for city
desc = getEffectDescriptionP(ENET_GEOMETRY_CAPITAL_MEDIUM_SHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "citybottom_medium_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- shadow for city
desc = getEffectDescriptionP(ENET_GEOMETRY_CAPITAL_SMALL_SHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "citybottom_small_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow


-- register new unit to logic
unitDesc = logic_getUnitDescP(99)
unitDesc.unit_res_id = ENET_UNIT_CAPITAL_MEDIUM
unitDesc.unit_icon_id = "8F30.dds"
unitDesc.small_icon_id = "8F21.dds"
unitDesc.HP = 0
unitDesc.MP = 0
unitDesc.WR = 0
unitDesc.min_WR = 0
unitDesc.WD = 0
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 0
unitDesc.transport = 3
unitDesc.value = 0
unitDesc.race = 0
unitDesc.fire_pause = 0.0
unitDesc.move_pause = 0.0
unitDesc.unit_info_scale = 0.0
unitDesc.scn_name = "City"












