
function units_carrier_alien_setup()
	units_setup_sea(7,true,true,ENET_EFFECT_GEOMETRY_CARRIERALIENSHADOW)
end

function units_carrier_alien_resetup()
	units_setup_sea(7,true,false,ENET_EFFECT_GEOMETRY_CARRIERALIENSHADOW)
end

function units_carrier_alien_select()
	units_select(27,6)
end

function units_carrier_alien_unselect()
	units_unselect()
end

function units_carrier_alien_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_carrier_alien_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_carrier_alien_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_carrier_alien_explode()
	units_explode_water1()
end

function units_carrier_alien_move()
	local unit = uniGetExecutor()
	local sound = unit:play3DSound("carrier_alien_move.wav",1)
	local steps = unit:addSimpleEffect(ENET_EFFECT_PS_SEATRANSPORT_WATERTRAY)
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNIT,MATH_PI * 0.4))
	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_LINEAR,60))
	steps:suspendedDestroy(1.0)
	sound:destroy()
end

function units_carrier_alien_fire()
end

registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_MOVE,"units_carrier_alien_move")
registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_FIRE1,"units_carrier_alien_fire")
registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_FIRE2,"units_carrier_alien_fire")
registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_SELECT,"units_carrier_alien_select")
registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_SELECTENEMY,"units_carrier_alien_selectenemy")
registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_UNSELECT,"units_carrier_alien_unselect")
registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_SETUP,"units_carrier_alien_setup")
registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_RESETUP,"units_carrier_alien_resetup")
registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_DAMAGED,"units_carrier_alien_damaged")
registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_EXPLODE,"units_carrier_alien_explode")
registerCommand(ENSCRIPTSET_CARRIER_ALIEN,ENC_HIGHLIGHT,"units_carrier_alien_highlight")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_CARRIER_ALIEN)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "carrier_alien.rmd"
desc.ScriptSet = ENSCRIPTSET_CARRIER_ALIEN
desc.MoveType = ENMOVE_SWIM
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_CARRIERALIENSHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "carrier_alien_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(25)
unitDesc.group = 1
unitDesc.order = 4
unitDesc.unit_res_id = ENET_UNIT_CARRIER_ALIEN
unitDesc.unit_icon_id = "Carrier_a_small_normal.dds"
unitDesc.active_id = "Carrier_a_small_active.dds"
unitDesc.pressed_id = "Carrier_a_small_pressed.dds"
unitDesc.small_icon_id = "Carrier_l_stats.dds"
unitDesc.big_icon_id = "Carrier_a_big_normal.dds"
unitDesc.HP = 7
unitDesc.MP = 30
unitDesc.WR = 6
unitDesc.min_WR = 1
unitDesc.WD = 0
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 3
unitDesc.transport = 4
unitDesc.value = 6
unitDesc.race = 1
unitDesc.fire_pause = 1.0
unitDesc.move_pause = 2.0
unitDesc.unit_info_scale = 0.04
unitDesc.scn_name = "CARRIERA"


