
function units_carrier_setup()
	units_setup_sea(7,false,true,ENET_EFFECT_GEOMETRY_CARRIERSHADOW)
end

function units_carrier_resetup()
	units_setup_sea(7,false,false,ENET_EFFECT_GEOMETRY_CARRIERSHADOW)
end

function units_carrier_select()
	units_select(27,6)
end

function units_carrier_unselect()
	units_unselect()
end

function units_carrier_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_carrier_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_carrier_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_carrier_explode()
	units_explode_water1()
end

function units_carrier_move()
	local unit = uniGetExecutor()
	local sound = unit:play3DSound("carrier_move.wav",1)
	local steps = unit:addSimpleEffect(ENET_EFFECT_PS_SEATRANSPORT_WATERTRAY)
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNIT,MATH_PI * 0.4))
	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_LINEAR,60))
	steps:suspendedDestroy(1.0)
	sound:destroy()
end

function units_carrier_fire()
end

registerCommand(ENSCRIPTSET_CARRIER,ENC_MOVE,"units_carrier_move")
registerCommand(ENSCRIPTSET_CARRIER,ENC_FIRE1,"units_carrier_fire")
registerCommand(ENSCRIPTSET_CARRIER,ENC_FIRE2,"units_carrier_fire")
registerCommand(ENSCRIPTSET_CARRIER,ENC_SELECT,"units_carrier_select")
registerCommand(ENSCRIPTSET_CARRIER,ENC_SELECTENEMY,"units_carrier_selectenemy")
registerCommand(ENSCRIPTSET_CARRIER,ENC_UNSELECT,"units_carrier_unselect")
registerCommand(ENSCRIPTSET_CARRIER,ENC_SETUP,"units_carrier_setup")
registerCommand(ENSCRIPTSET_CARRIER,ENC_RESETUP,"units_carrier_resetup")
registerCommand(ENSCRIPTSET_CARRIER,ENC_DAMAGED,"units_carrier_damaged")
registerCommand(ENSCRIPTSET_CARRIER,ENC_EXPLODE,"units_carrier_explode")
registerCommand(ENSCRIPTSET_CARRIER,ENC_HIGHLIGHT,"units_carrier_highlight")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_CARRIER)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "carrier.rmd"
desc.ScriptSet = ENSCRIPTSET_CARRIER
desc.MoveType = ENMOVE_SWIM
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_CARRIERSHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "carrier_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(12)
unitDesc.group = 1
unitDesc.order = 4
unitDesc.unit_res_id = ENET_UNIT_CARRIER
unitDesc.unit_icon_id = "Carrier_h_small_normal.dds"
unitDesc.active_id = "Carrier_h_small_active.dds"
unitDesc.pressed_id = "Carrier_h_small_pressed.dds"
unitDesc.big_icon_id = "Carrier_h_big_normal.dds"
unitDesc.small_icon_id = "Carrier_u_stats.dds"
unitDesc.HP = 7
unitDesc.MP = 30
unitDesc.WR = 6
unitDesc.min_WR = 1
unitDesc.WD = 0
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 3
unitDesc.transport = 4
unitDesc.value = 6
unitDesc.race = 0
unitDesc.fire_pause = 1.0
unitDesc.move_pause = 2.0
unitDesc.unit_info_scale = 0.04
unitDesc.scn_name = "CARRIER"


