
function cruiser_shot_fly1()
	local explosion = uniGetExecutor()
	explosion:setTransformOwner()
	local sound = explosion:play3DSound("Leviathan_missile_fire.wav",0):destroy()
	local mshotsmoke = explosion:addSimpleEffect(ENET_EFFECT_PS_CRUISERSHOT_SMOKE)
	waitDeath(explosion:forwardFly(uniGetTarget(),150))
	uniGetTarget():executeCommand(ENC_DAMAGED)
	mshotsmoke:suspendedDestroy(1.5)
	local exp_ps = explosion:addSimpleEffect(ENET_EFFECT_PS_CRUISERSHOT_EXPLOSION2)
	pause(0.0)
	exp_ps:suspendedDestroy(2.5)
	pause(1.5)
	explosion:suspendedDestroy(2.0)
end

function cruiser_shot_fly2()
	local explosion = uniGetExecutor()
	explosion:setTransformOwner()
	local mshot1 = explosion:addSimpleEffect(ENET_EFFECT_PS_CRUISERSHOT_FLY)
	local shotlight = explosion:addSimpleEffect(ENET_EFFECT_CRUISER_LIGHTSPOT2)
	waitDeath(explosion:parabolicFly(uniGetTarget()))
	uniGetTarget():executeCommand(ENC_DAMAGED)
	mshot1:suspendedDestroy(4.0)
	local exp_ps = explosion:addSimpleEffect(ENET_EFFECT_PS_CRUISERSHOT_EXPLOSION)
	pause(1.0)
	exp_ps:suspendedDestroy(1.5)
	shotlight:destroy()
	pause(1.5)
	explosion:destroy()
end

registerCommand(ENSCRIPTSET_CRUISERSHOT,ENC_FIRE1,"cruiser_shot_fly1")
registerCommand(ENSCRIPTSET_CRUISERSHOT2,ENC_FIRE2,"cruiser_shot_fly2")

--
-- dummy effect creation test
--
desc = getEffectDescriptionP(ENET_EFFECT_CRUISERSHOT_FLY)
desc.ClassID = ENCLASS_DUMMY
desc.EffectClassType = ENECT_GEOMETRY

desc.ScriptSet = ENSCRIPTSET_CRUISERSHOT
desc.RelativePosition = ENLOCALPOS_NOTSPECIFIED
local vzbzd1 = D3DXVECTOR3:new(0,0,0)
desc.LocalPosition = vzbzd1
vzbzd1:delete()
desc.MoveType = ENMOVE_FLY

desc.ActivityType = ENACT_COMMANDSEMIACTIVE
--
-- end dummy effect creation test
--



--
-- dummy effect creation test
--
desc = getEffectDescriptionP(ENET_EFFECT_CRUISERSHOT_FLY2)
desc.ClassID = ENCLASS_DUMMY
desc.EffectClassType = ENECT_GEOMETRY

desc.ScriptSet = ENSCRIPTSET_CRUISERSHOT2
desc.RelativePosition = ENLOCALPOS_NOTSPECIFIED
local vzbzd2 = D3DXVECTOR3:new(0,0,0)
desc.LocalPosition = vzbzd2
vzbzd2:delete()
desc.MoveType = ENMOVE_FLY

desc.ActivityType = ENACT_COMMANDSEMIACTIVE
--
-- end dummy effect creation test
--






--
-- lightsource creation test
--
desc = getEffectDescriptionP(ENET_EFFECT_CRUISER_LIGHTSPOT)
desc.ClassID = ENCLASS_LIGHTSOURCE
desc.EffectClassType = ENECT_LIGHTSOURCE

desc.ScriptSet = ENSCRIPTSET_UNKNOWN
desc.RelativePosition = ENLOCALPOS_NOTSPECIFIED
local vzbzd3 = D3DXVECTOR3:new(0,0,0)
desc.LocalPosition = vzbzd3
vzbzd3:delete()
desc.ActivityType = ENACT_SEMIACTIVE

-- add interpolators
desc:clearInterpolators()

local interpolator = createInterpolator()
interpolator:addKey(0.0,20.0)
interpolator:addKey(0.2,100.0)
interpolator:addKey(4.0,20.0)
interpolator:finalize(false)
-- add interpolator on light range
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_LIGHT_RANGE))

local interpolator = createInterpolator()
interpolator:addKey(0.0,0.0)
interpolator:addKey(0.2,1.0)
interpolator:addKey(4.0,0.0)
interpolator:finalize(false)
-- add interpolator on R B colors
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_R))


local interpolator = createInterpolator()
interpolator:addKey(0.0,0.0)
interpolator:addKey(0.2,0.4)
interpolator:addKey(4.0,0.0)
interpolator:finalize(false)
-- add interpolator on R B colors
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_B))


local interpolator = createInterpolator()
interpolator:addKey(0.0,0.0)
interpolator:addKey(0.2,0.6)
interpolator:addKey(4.0,0.0)
interpolator:finalize(false)
-- add interpolator on R B colors
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_G))


--
-- end lightsource creation description
--





--
-- lightsource creation test
--
desc = getEffectDescriptionP(ENET_EFFECT_CRUISER_LIGHTSPOT2)
desc.ClassID = ENCLASS_LIGHTSOURCE
desc.EffectClassType = ENECT_LIGHTSOURCE

desc.ScriptSet = ENSCRIPTSET_UNKNOWN
desc.RelativePosition = ENLOCALPOS_NOTSPECIFIED
local vzbzd4 = D3DXVECTOR3:new(0,0,0)
desc.LocalPosition = vzbzd4
vzbzd4:delete()
desc.ActivityType = ENACT_SEMIACTIVE

-- add interpolators
desc:clearInterpolators()

local interpolator = createInterpolator()
interpolator:addKey(0.0,20.0)
interpolator:addKey(3.0,170.0)
interpolator:addKey(5.0,20.0)
interpolator:finalize(false)
-- add interpolator on light range
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_LIGHT_RANGE))

local interpolator = createInterpolator()
interpolator:addKey(0.0,0.1)
interpolator:addKey(5.0,0.1)
interpolator:finalize(false)
-- add interpolator on R B colors
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_R))

local interpolator = createInterpolator()
interpolator:addKey(0.0,0.4)
interpolator:addKey(5.0,0.4)
interpolator:finalize(false)
-- add interpolator on R B colors
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_B))

local interpolator = createInterpolator()
interpolator:addKey(0.0,0.25)
interpolator:addKey(5.0,0.25)
interpolator:finalize(false)
-- add interpolator on R B colors
desc:addInterpolator(interpolator,getFieldOffset(EN_FIELD_DIFFUSE_G))



--
-- end lightsource creation description
--








