
function units_destroyer_alien_setup()
	units_setup_sea(5,true,true,ENET_EFFECT_GEOMETRY_TORPEDOSHIPALIENSHADOW)
end

function units_destroyer_alien_resetup()
	units_setup_sea(5,true,false,ENET_EFFECT_GEOMETRY_TORPEDOSHIPALIENSHADOW)
end

function units_destroyer_alien_select()
	units_select(17,2)
end

function units_destroyer_alien_unselect()
	units_unselect()
end

function units_destroyer_alien_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_destroyer_alien_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_destroyer_alien_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_destroyer_alien_explode()
	units_explode_water3()
end

function units_destroyer_alien_move()
	local unit = uniGetExecutor()
	local sound = unit:play3DSound("destroyer_alien_move.wav",1)
	local steps = unit:addSimpleEffect(ENET_EFFECT_EFFECTEMITTER_SHIP_WATERTRAY)
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNIT,MATH_PI * 0.7))
	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_LINEAR,80))
	steps:suspendedDestroy(2.0)
	sound:destroy()
end

function units_destroyer_alien_fire1()
	local unit = uniGetExecutor()
	uniSetLife(uniGetLife() / 4.0)
	local gt = unit:getBone(ENBT_GUNTOWER)
	local sound = gt:play3DSound("destroyer_alien_guntower_rotate.wav",1)
	waitDeath(gt:addRotationEffect(ENET_EFFECT_ROTATE_GUNTOWERTOTARGET,MATH_PI,uniGetTarget()))
	sound:stopSound()
	pause(0.3)
	gt:getBone(ENBT_FIRE1,0):addBulletEffect(ENET_EFFECT_BULLET_REDLASERBOLT):executeCommand(ENC_FIRE1)
	pause(0.25)
	gt:getBone(ENBT_FIRE1,1):addBulletEffect(ENET_EFFECT_BULLET_REDLASERBOLT):executeCommand(ENC_FIRE1)
	pause(0.25)
	gt:getBone(ENBT_FIRE1,0):addBulletEffect(ENET_EFFECT_BULLET_REDLASERBOLT):executeCommand(ENC_FIRE1)
	pause(0.25)
	gt:getBone(ENBT_FIRE1,1):addBulletEffect(ENET_EFFECT_BULLET_REDLASERBOLT):executeCommand(ENC_FIRE1)
	unit:addFireArrow()
end

function units_destroyer_alien_fire2()
	local unit = uniGetExecutor()
	uniSetLife(uniGetLife() / 2.0)
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNIT,MATH_PI * 0.7,uniGetTarget()))
	local gn = unit:getBone(ENBT_GUNNEST)
	pause(0.3)
	gn:getBone(ENBT_FIRE2,0):addBulletEffect(ENET_EFFECT_BULLET_ALIENTORPEDO):executeCommand(ENC_FIRE1)
	pause(1.0)
	gn:getBone(ENBT_FIRE2,1):addBulletEffect(ENET_EFFECT_BULLET_ALIENTORPEDO):executeCommand(ENC_FIRE1)
	unit:addFireArrow()
end

registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_MOVE,"units_destroyer_alien_move")
registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_FIRE1,"units_destroyer_alien_fire1")
registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_FIRE2,"units_destroyer_alien_fire2")
registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_SELECT,"units_destroyer_alien_select")
registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_SELECTENEMY,"units_destroyer_alien_selectenemy")
registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_UNSELECT,"units_destroyer_alien_unselect")
registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_SETUP,"units_destroyer_alien_setup")
registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_RESETUP,"units_destroyer_alien_resetup")
registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_DAMAGED,"units_destroyer_alien_damaged")
registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_EXPLODE,"units_destroyer_alien_explode")
registerCommand(ENSCRIPTSET_TORPEDOSHIP_ALIEN,ENC_HIGHLIGHT,"units_destroyer_alien_highlight")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_TORPEDOSHIP_ALIEN)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "torpedoship_alien.rmd"
desc.ScriptSet = ENSCRIPTSET_TORPEDOSHIP_ALIEN
desc.MoveType = ENMOVE_SWIM
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_TORPEDOSHIPALIENSHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "torpedoship_alien_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(21)
unitDesc.group = 1
unitDesc.order = 0
unitDesc.unit_res_id = ENET_UNIT_TORPEDOSHIP_ALIEN
unitDesc.unit_icon_id = "Torpedoship_a_small_normal.dds"
unitDesc.active_id = "Torpedoship_a_small_active.dds"
unitDesc.pressed_id = "Torpedoship_a_small_pressed.dds"
unitDesc.small_icon_id = "Torpedoship_l_stats.dds"
unitDesc.big_icon_id = "Torpedoship_a_big_normal.dds"
unitDesc.HP = 5
unitDesc.MP = 30
unitDesc.WR = 2
unitDesc.min_WR = 1
unitDesc.WD = 1
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 3
unitDesc.transport = 0
unitDesc.value = 2
unitDesc.race = 1
unitDesc.fire_pause = 0.8
unitDesc.move_pause = 1.0
unitDesc.unit_info_scale = 0.04
unitDesc.scn_name = "DESTROYERA"

------------------------------------------------------------------------------------------------------
------------------------ effects related to unit------------------------------------------------------
------------------------------------------------------------------------------------------------------

function bullets_torpedoalien_fire()
	local bullet = uniGetExecutor()
	bullet:setTransformOwner()
	local sound = bullet:play3DSound("destroyer_alien_torpedo_fly.wav",1)
	local track = bullet:addSimpleEffect(ENET_EFFECT_PS_TORPEDO_WATERTRAY)
	waitDeath(bullet:addMoveEffect(ENET_EFFECT_MOVE_TORPEDOSWIM,100,uniGetTarget()),100)
	sound:destroy()
	track:suspendedDestroy(1.0)
	bullet:play3DSound("destroyer_alien_torpedo_explode.wav",0):destroy()
	bullet:setVisibility(false,true)
	bullet:addSimpleEffect(ENET_EFFECT_LIGHT_ROCKETEXPLODE):delayedDestroy(2.0)
	bullet:addSimpleEffect(ENET_EFFECT_PS_TORPEDOHIT):suspendedDestroy(2.0)
	uniGetTarget():executeCommand(ENC_DAMAGED)
	pause(2.0)
	bullet:destroy()
end

registerCommand(ENSCRIPTSET_BULLET_TORPEDO_ALIEN,ENC_FIRE1,"bullets_torpedoalien_fire")
