
function units_generator_setup()
	building_setup(ENET_GEOMETRY_GENERATOR_SHADOW)
	local unit = uniGetExecutor()
	if(unit:getLife() > 0.0) then 
		unit:addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_GENERATOR_GLOW)
	end
end

function units_generator_resetup()
	building_setup(ENET_GEOMETRY_GENERATOR_SHADOW)
	local unit = uniGetExecutor()
	if(unit:getLife() > 0.0) then 
		unit:addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_GENERATOR_GLOW)
	end
end

function units_generator_select()
	units_select(12,1)
end

function units_generator_unselect()
	units_unselect()
end

function units_generator_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_generator_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_generator_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_generator_explode()
	local unit = uniGetExecutor()
	local field = unit:findEffect(ENET_EFFECT_PS_ENVIRONMENT_GENERATOR_GLOW)
	if(field ~= nil) then field:suspendedDestroy(1.0) end
	units_explode_base()
end

function units_generator_move()
end

function units_generator_fire()
end

registerCommand(ENSCRIPTSET_GENERATOR,ENC_MOVE,"units_generator_move")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_FIRE1,"units_generator_fire")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_FIRE2,"units_generator_fire")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_SELECT,"units_generator_select")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_SELECTENEMY,"units_generator_selectenemy")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_UNSELECT,"units_generator_unselect")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_SETUP,"units_generator_setup")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_RESETUP,"units_generator_resetup")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_DAMAGED,"units_generator_damaged")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_EXPLODE,"units_generator_explode")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_HIGHLIGHT,"units_generator_highlight")
registerCommand(ENSCRIPTSET_GENERATOR,ENC_INSIDE,"units_inside")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_GENERATOR)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "generator.rmd"
desc.ScriptSet = ENSCRIPTSET_GENERATOR
desc.MoveType = ENMOVE_GROUND
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_CAPITAL
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_GEOMETRY_GENERATOR_SHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "generator_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(55)
unitDesc.group = 0
unitDesc.order = 0
unitDesc.unit_res_id = ENET_UNIT_GENERATOR
unitDesc.unit_icon_id = "Smallrobot_h_small_normal.dds"
unitDesc.active_id = "Smallrobot_h_small_active.dds"
unitDesc.pressed_id = "Smallrobot_h_small_pressed.dds"
unitDesc.big_icon_id = "Psi_generator_ico.dds"
unitDesc.small_icon_id = "Smallrobot_u_stats.dds"
unitDesc.HP = 9
unitDesc.MP = 0
unitDesc.WR = 1
unitDesc.min_WR = 1
unitDesc.WD = 1
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 0
unitDesc.transport = 0
unitDesc.value = 1
unitDesc.race = 0
unitDesc.fire_pause = 0.2
unitDesc.move_pause = 0.5
unitDesc.unit_info_scale = 0.08
unitDesc.scn_name = "PSYGEN"

------------------------------------------------------------------------------------------------------
------------------------ effects related to unit------------------------------------------------------
------------------------------------------------------------------------------------------------------

