
function units_guardtower_alien_setup()
	units_setup(9,true,ENET_EFFECT_PS_SETUPSMOKE_SMALL,ENET_EFFECT_GEOMETRY_GUARDTOWERALIENSHADOW)
end

function units_guardtower_alien_resetup()
	units_setup(9,true,nil,ENET_EFFECT_GEOMETRY_GUARDTOWERALIENSHADOW)
end

function units_guardtower_alien_select()
	units_select(22,4)
end

function units_guardtower_alien_unselect()
	units_unselect()
end

function units_guardtower_alien_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_guardtower_alien_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_guardtower_alien_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_guardtower_alien_explode()
	units_explode_big1()
end

function units_guardtower_alien_move()
end

function units_guardtower_alien_fire()
	local unit = uniGetExecutor()
	uniSetLife(uniGetLife() / 4.0)
	local gt = unit:getBone(ENBT_GUNTOWER)
	local sound = gt:play3DSound("guardtower_alien_guntower_rotate.wav",1)
	waitDeath(gt:addRotationEffect(ENET_EFFECT_ROTATE_GUNTOWERTOTARGET,MATH_PI / 2.0,uniGetTarget()))
	sound:stopSound()
	local firespots = {}
	firespots[0] = gt:getBone(ENBT_FIRE1,0)
	firespots[1] = gt:getBone(ENBT_FIRE1,1)
	local gun = gt:getBone(ENBT_GUN)
	waitDeath(gun:addRotationEffect(ENET_EFFECT_ROTATE_GUNTOTARGET,MATH_PI / 3.0,uniGetTarget()))

	local i
	for i = 0,1 do
		firespots[0]:addBulletEffect(ENET_EFFECT_BULLET_BLUESPIRALLASERBOLT):executeCommand(ENC_FIRE1)
		pause(0.2)
		gt:gunRecoil(0,0.4,30)

		firespots[1]:addBulletEffect(ENET_EFFECT_BULLET_BLUESPIRALLASERBOLT):executeCommand(ENC_FIRE1)
		pause(0.2)
		gt:gunRecoil(1,0.4,30)
	end

	unit:addFireArrow()
end

registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_MOVE,"units_guardtower_alien_move")
registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_FIRE1,"units_guardtower_alien_fire")
registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_FIRE2,"units_guardtower_alien_fire")
registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_SELECT,"units_guardtower_alien_select")
registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_SELECTENEMY,"units_guardtower_alien_selectenemy")
registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_UNSELECT,"units_guardtower_alien_unselect")
registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_SETUP,"units_guardtower_alien_setup")
registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_RESETUP,"units_guardtower_alien_resetup")
registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_DAMAGED,"units_guardtower_alien_damaged")
registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_EXPLODE,"units_guardtower_alien_explode")
registerCommand(ENSCRIPTSET_GUARDTOWER_ALIEN,ENC_HIGHLIGHT,"units_guardtower_alien_highlight")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_GUARDTOWER_ALIEN)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "guardtower_alien.rmd"
desc.ScriptSet = ENSCRIPTSET_GUARDTOWER_ALIEN
desc.MoveType = ENMOVE_SWIM
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_GUARDTOWERALIENSHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "guardtower_alien_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(18)
unitDesc.group = 2
unitDesc.order = 6
unitDesc.unit_res_id = ENET_UNIT_GUARDTOWER_ALIEN
unitDesc.unit_icon_id = "Guardtower_a_small_normal.dds"
unitDesc.active_id = "Guardtower_a_small_active.dds"
unitDesc.pressed_id = "Guardtower_a_small_pressed.dds"
unitDesc.small_icon_id = "Guardtower_l_stats.dds"
unitDesc.big_icon_id = "Guardtower_a_big_normal.dds"
unitDesc.HP = 9
unitDesc.MP = 0
unitDesc.WR = 4
unitDesc.min_WR = 1
unitDesc.WD = 2
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 1
unitDesc.transport = 0
unitDesc.value = 4
unitDesc.race = 1
unitDesc.fire_pause = 0.75
unitDesc.move_pause = 0.7
unitDesc.unit_info_scale = 0.03
unitDesc.scn_name = "GTOWERA"

------------------------------------------------------------------------------------------------------
------------------------ effects related to unit------------------------------------------------------
------------------------------------------------------------------------------------------------------

function bullets_bluespirallaserbolt_fire()
	local bullet = uniGetExecutor()
	local sound = bullet:play3DSound("guardtower_alien_lightning_fire.wav",1)
	local light = bullet:addSimpleEffect(ENET_EFFECT_LIGHT_BLUESPIRALLASERBOLTFLY)
	local track = bullet:addSimpleEffect(ENET_EFFECT_PS_BLUESPIRALLASERBOLTFLY)
	track:suspend()
	pause(0.1)
	bullet:setTransformOwner()
	waitDeath(bullet:addMoveEffect(ENET_EFFECT_MOVE_LINEARFLY,500,uniGetTarget()),1000)
	sound:destroy()
	light:destroy()
	track:destroy()
	bullet:addSimpleEffect(ENET_EFFECT_LIGHT_BLUESPIRALLASERBOLTHIT):delayedDestroy(1.0)
	bullet:addSimpleEffect(ENET_EFFECT_PS_BLUESPIRALLASERBOLTHIT):suspendedDestroy(1.0)
	uniGetTarget():executeCommand(ENC_DAMAGED)
	pause(1.0)
	bullet:destroy()
end

registerCommand(ENSCRIPTSET_BULLET_BLUESPIRALLASERBOLT,ENC_FIRE1,"bullets_bluespirallaserbolt_fire")
