
function units_oilplatform_setup()
	building_setup(ENET_GEOMETRY_OILPLATFORM_SHADOW)
	uniGetExecutor():getBone(ENBT_FAN,0):addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_OILPLATFORMFIRE)
end

function units_oilplatform_resetup()
	building_setup(ENET_GEOMETRY_OILPLATFORM_SHADOW)
	uniGetExecutor():getBone(ENBT_FAN,0):addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_OILPLATFORMFIRE)
end

function units_oilplatform_select()
	units_select(12,1)
end

function units_oilplatform_unselect()
	units_unselect()
end

function units_oilplatform_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_oilplatform_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_oilplatform_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_oilplatform_explode()
	units_explode_oilplatform()
end

function units_oilplatform_move()
end

function units_oilplatform_fire()
end

registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_MOVE,"units_oilplatform_move")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_FIRE1,"units_oilplatform_fire")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_FIRE2,"units_oilplatform_fire")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_SELECT,"units_oilplatform_select")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_SELECTENEMY,"units_oilplatform_selectenemy")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_UNSELECT,"units_oilplatform_unselect")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_SETUP,"units_oilplatform_setup")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_RESETUP,"units_oilplatform_resetup")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_DAMAGED,"units_oilplatform_damaged")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_EXPLODE,"units_oilplatform_explode")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_HIGHLIGHT,"units_oilplatform_highlight")
registerCommand(ENSCRIPTSET_OILPLATFORM,ENC_INSIDE,"units_inside")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_OILPLATFORM)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "oilplatform.rmd"
desc.ScriptSet = ENSCRIPTSET_OILPLATFORM
desc.MoveType = ENMOVE_SWIM
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_CAPITAL
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_GEOMETRY_OILPLATFORM_SHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "oilplatform_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(56)
unitDesc.group = 0
unitDesc.order = 0
unitDesc.unit_res_id = ENET_UNIT_OILPLATFORM
unitDesc.unit_icon_id = "Smallrobot_h_small_normal.dds"
unitDesc.active_id = "Smallrobot_h_small_active.dds"
unitDesc.pressed_id = "Smallrobot_h_small_pressed.dds"
unitDesc.big_icon_id = "Oilplatform_h_big_normal.dds"
unitDesc.small_icon_id = "80A0.dds"
unitDesc.HP = 4
unitDesc.MP = 0
unitDesc.WR = 0
unitDesc.min_WR = 0
unitDesc.WD = 0
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 3
unitDesc.transport = 0
unitDesc.value = 3
unitDesc.race = 0
unitDesc.fire_pause = 0.2
unitDesc.move_pause = 0.5
unitDesc.unit_info_scale = 0.08
unitDesc.scn_name = "OILPLATFORM"

------------------------------------------------------------------------------------------------------
------------------------ effects related to unit------------------------------------------------------
------------------------------------------------------------------------------------------------------

