
function units_platform_setup()
	local unit = uniGetExecutor()
	units_setup(3,false,ENET_EFFECT_PS_SETUPSMOKE_SMALL,ENET_EFFECT_GEOMETRY_PLATFORMSHADOW,true)
	unit:getBone(ENBT_FAN,0):addRotationEffect(ENET_EFFECT_ROTATE_RADAR,MATH_PI)
	unit:getBone(ENBT_FAN,1):addRotationEffect(ENET_EFFECT_ROTATE_RADAR,MATH_PI)
	unit:getBone(ENBT_FAN,2):addRotationEffect(ENET_EFFECT_ROTATE_RADAR,MATH_PI)
	unit:getBone(ENBT_FAN,3):addRotationEffect(ENET_EFFECT_ROTATE_RADAR,MATH_PI)

	unit:getBone(ENBT_FAN,0):addSimpleEffect(ENET_EFFECT_BINDEDSPRITE_PLATFORMVINT)
	unit:getBone(ENBT_FAN,1):addSimpleEffect(ENET_EFFECT_BINDEDSPRITE_PLATFORMVINT)
	unit:getBone(ENBT_FAN,2):addSimpleEffect(ENET_EFFECT_BINDEDSPRITE_PLATFORMVINT)
	unit:getBone(ENBT_FAN,3):addSimpleEffect(ENET_EFFECT_BINDEDSPRITE_PLATFORMVINT)

	unit:getBone(ENBT_FAN,0):addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_PLATFORMSMOKE)
	unit:getBone(ENBT_FAN,1):addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_PLATFORMSMOKE)
	unit:getBone(ENBT_FAN,2):addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_PLATFORMSMOKE)
	unit:getBone(ENBT_FAN,3):addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_PLATFORMSMOKE)
end

function units_platform_resetup()
	local unit = uniGetExecutor()
	units_setup(3,false,nil,ENET_EFFECT_GEOMETRY_PLATFORMSHADOW,true)
	unit:getBone(ENBT_FAN,0):addRotationEffect(ENET_EFFECT_ROTATE_RADAR,MATH_PI)
	unit:getBone(ENBT_FAN,1):addRotationEffect(ENET_EFFECT_ROTATE_RADAR,MATH_PI)
	unit:getBone(ENBT_FAN,2):addRotationEffect(ENET_EFFECT_ROTATE_RADAR,MATH_PI)
	unit:getBone(ENBT_FAN,3):addRotationEffect(ENET_EFFECT_ROTATE_RADAR,MATH_PI)

	unit:getBone(ENBT_FAN,0):addSimpleEffect(ENET_EFFECT_BINDEDSPRITE_PLATFORMVINT)
	unit:getBone(ENBT_FAN,1):addSimpleEffect(ENET_EFFECT_BINDEDSPRITE_PLATFORMVINT)
	unit:getBone(ENBT_FAN,2):addSimpleEffect(ENET_EFFECT_BINDEDSPRITE_PLATFORMVINT)
	unit:getBone(ENBT_FAN,3):addSimpleEffect(ENET_EFFECT_BINDEDSPRITE_PLATFORMVINT)

	unit:getBone(ENBT_FAN,0):addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_PLATFORMSMOKE)
	unit:getBone(ENBT_FAN,1):addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_PLATFORMSMOKE)
	unit:getBone(ENBT_FAN,2):addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_PLATFORMSMOKE)
	unit:getBone(ENBT_FAN,3):addSimpleEffect(ENET_EFFECT_PS_ENVIRONMENT_PLATFORMSMOKE)
end

function units_platform_select()
	units_select(32)
end

function units_platform_unselect()
	units_unselect()
end

function units_platform_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_platform_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_platform_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_platform_explode()
	units_explode_big1()
end

function units_platform_fire()
end

function units_platform_move()
	local unit = uniGetExecutor()
	local sound = unit:play3DSound("something moves.wav",1)
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNIT,MATH_PI * 0.6))
	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_LINEAR,60))
	sound:destroy()
end

function units_platform_load()
	local unit = uniGetExecutor()
	local cargo = uniGetTarget()
	local sound = unit:play3DSound("something moves.wav",1)
	units_waitCommandByUID(cargo,unit:getCurrentCommandUID() - 1)
	waitDeath(unit:parabolicTargetting(cargo))
	sound:destroy()
	unit:addAnimationToQueue(ENAT_IDLETIMEOUT1,1)
	unit:addAnimationToQueue(ENAT_FIREPOSITION1,MATH_INFINITY)
	unit:addAnimationToQueue(ENAT_IDLETIMEOUT2,1)
	uniSetPosition(unit:getBone(ENBT_FIRE1):getWorldPosition())
	unit:play3DSound("platform_opens.wav",0):destroy()
	local ground = units_addGround(unit,ENET_PLATFORM_GROUND)
	local movecmd_uid = cargo:executeCommand(ENC_MOVE,true)
	cargo:terminateCommand()
	cargo:executeCommand(ENC_INSIDE,true)
	while(cargo:getCurrentCommandUID() == movecmd_uid) do pause() end
	cargo:setTransformOwner(units_findfreefirespot(unit,1))
	unit:setCurrentAnimationRepeatCount(0)
	cargo:setVisibility(true,true) 
	cargo:terminateCommand()
end

function units_platform_unload()
	local unit = uniGetExecutor()
	local cargo = uniGetTarget()
	units_waitCommandByUID(cargo,unit:getCurrentCommandUID() - 1)
	local pos = uniGetPosition()
	local sound = unit:play3DSound("something moves.wav",1)
	waitDeath(unit:parabolicTargetting(pos))
	sound:destroy()
	unit:play3DSound("platform_opens2.wav",0):destroy()
	unit:addAnimationToQueue(ENAT_IDLETIMEOUT1,1)
	unit:addAnimationToQueue(ENAT_FIREPOSITION1,MATH_INFINITY)
	unit:addAnimationToQueue(ENAT_IDLETIMEOUT2,1)
	local ground = units_addGround(unit,ENET_PLATFORM_GROUND)
	cargo:setTransformOwner()
	local movecmd_uid = cargo:executeCommand(ENC_MOVE,true)
	cargo:terminateCommand()
	cargo:executeCommand(ENC_INSIDE,true)
	while(cargo:getCurrentCommandUID() == movecmd_uid) do pause() end
	unit:setCurrentAnimationRepeatCount(0)
	cargo:terminateCommand()
end

function units_platform_transfer()
	local unit = uniGetExecutor()
	local cargo = uniGetTarget()
	units_waitCommandByUID(cargo,unit:getCurrentCommandUID() - 1)
	local from = cargo:getTransformOwner():getTransformOwner()
	local fromType = from:getEffectType()
	units_waitCommandByUID(from,unit:getCurrentCommandUID() - 2)	
	if(fromType == ENET_UNIT_PLATFORM) then
		waitDeath(from:parabolicTargetting(unit))
		from:addAnimationToQueue(ENAT_IDLETIMEOUT1,1)
		from:addAnimationToQueue(ENAT_FIREPOSITION1,MATH_INFINITY)
		from:addAnimationToQueue(ENAT_IDLETIMEOUT2,1)
		local ground = units_addGround(from,ENET_PLATFORM_GROUND)
		cargo:setTransformOwner()
		units_platform_load()
		from:setCurrentAnimationRepeatCount(0)
		from:terminateCommand()
	elseif(fromType == ENET_UNIT_LANDTRANSPORT or fromType == ENET_UNIT_SEATRANSPORT) then
		waitDeath(from:parabolicTargetting(unit))
		cargo:setTransformOwner()
		from:addAnimationToQueue(ENAT_PREPAREFORFIRE1,1)
		from:addAnimationToQueue(ENAT_FIREPOSITION1,MATH_INFINITY)
		from:addAnimationToQueue(ENAT_AFTERFIRE1,1)
		local g_type = ENET_STRANSPORT_GROUND
		if(fromType == ENET_UNIT_LANDTRANSPORT) then g_type = ENET_LTRANSPORT_GROUND end
		local ground = units_addGround(from,g_type)
		cargo:setTransformOwner()
		cargo:setScale(0.4,0.4,0.4)
		cargo:setVisibility(true,false)
		units_platform_load()
		units_unload_growth(cargo)
		from:setCurrentAnimationRepeatCount(0)
		from:terminateCommand()
	else
		consoleWrite("attempt to reload from unknown transport type!!!")
	end
end

registerCommand(ENSCRIPTSET_PLATFORM,ENC_MOVE,"units_platform_move")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_FIRE1,"units_platform_fire")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_FIRE2,"units_platform_fire")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_SELECT,"units_platform_select")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_SELECTENEMY,"units_platform_selectenemy")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_UNSELECT,"units_platform_unselect")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_SETUP,"units_platform_setup")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_RESETUP,"units_platform_resetup")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_DAMAGED,"units_platform_damaged")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_EXPLODE,"units_platform_explode")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_HIGHLIGHT,"units_platform_highlight")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_LOAD,"units_platform_load")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_UNLOAD,"units_platform_unload")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_TRANSFER,"units_platform_transfer")
registerCommand(ENSCRIPTSET_PLATFORM,ENC_INSIDE,"units_inside")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_PLATFORM)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "platform.rmd"
desc.ScriptSet = ENSCRIPTSET_PLATFORM
desc.MoveType = ENMOVE_AMPHIBIAN
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human
desc.isPlacesVisible = true

--desc.Geometry.isCollisionable = true

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_PLATFORMSHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "platform_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(32)
unitDesc.group = 2
unitDesc.order = 1
--unitDesc.unit_res_id = ENET_UNIT_PLATFORM
unitDesc.unit_res_id = ENET_UNIT_PLATFORM
unitDesc.unit_icon_id = "Platform_h_small_normal.dds"
unitDesc.active_id = "Platform_h_small_active.dds"
unitDesc.pressed_id = "Platform_h_small_pressed.dds"
unitDesc.big_icon_id = "Platform_h_big_normal.dds"
unitDesc.small_icon_id = "Platform_u_stats.dds"
unitDesc.HP = 3
unitDesc.MP = 30
unitDesc.WR = 0
unitDesc.min_WR = 0
unitDesc.WD = 0
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 7
unitDesc.transport = 1
unitDesc.value = 2
unitDesc.race = 0
unitDesc.fire_pause = 0.6
unitDesc.move_pause = 0.5
unitDesc.unit_info_scale = 0.07
unitDesc.scn_name = "BPLATFORM"

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

desc = getEffectDescription(ENET_EFFECT_SPRITE_EXPLOSION)
desc.FileName = "platform_vint.dds"
desc.OrientedSprite.xsize = 11
desc.OrientedSprite.ysize = 11
desc.OrientedSprite.SpriteType = 2
desc.MaterialColors.Emissive.r = 1.0;
desc.MaterialColors.Emissive.g = 1.0;
desc.MaterialColors.Emissive.b = 1.0;
desc.MaterialColors.Emissive.a = 1.0;
changeEffect(ENET_EFFECT_BINDEDSPRITE_PLATFORMVINT,desc)


------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
desc = getEffectDescription(ENET_EFFECT_GEOMETRY_VEGETATION_FURPALM)
desc.FileName = "platform_ground.smd"
desc.effectUsageType = ENEUT_GENERIC
desc.Geometry.isCollisionable = true
changeEffect(ENET_PLATFORM_GROUND,desc)
