
function units_rlauncher_alien_setup()
	units_setup(3,true,ENET_EFFECT_PS_SETUPSMOKE_LARGE,ENET_EFFECT_GEOMETRY_BIGROCKETALIENSHADOW)
	units_reloadfirespots(uniGetExecutor(),2,ENET_EFFECT_BULLET_BIGROCKETALIENROCKET)
end

function units_rlauncher_alien_resetup()
	units_setup(3,true,nil,ENET_EFFECT_GEOMETRY_BIGROCKETALIENSHADOW)
	units_reloadfirespots(uniGetExecutor(),2,ENET_EFFECT_BULLET_BIGROCKETALIENROCKET)
end

function units_rlauncher_alien_select()
	units_select(22,4)
end

function units_rlauncher_alien_unselect()
	units_unselect()
end

function units_rlauncher_alien_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_rlauncher_alien_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_rlauncher_alien_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_rlauncher_alien_explode()
	units_explode_big1()
end

function units_rlauncher_alien_move()
	local unit = uniGetExecutor()
	local sound = unit:play3DSound("bigrocket_alien_move.wav",1)
	local steps = {}
	local i = 0;
	for i = 0,1 do
		steps[i] = unit:getBone(ENBT_STEPEMITTER,i):addSimpleEffect(ENET_EFFECT_DYNAMICGEOMETRY_LIGHTTANKSTEPSEMITTER)
		steps[i+2] = unit:getBone(ENBT_STEPEMITTER,i):addSimpleEffect(ENET_EFFECT_PS_NEWTRACKSMOKE3)
	end
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNIT,MATH_PI * 1.0))
	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_LINEAR,100))
	sound:destroy()
	unit:play3DSound("bigrocket_alien_stop.wav",0):destroy()
	for i = 0,1 do
		if(unit:getScale() < 1.0) then 
			steps[i]:destroy()
		else
			steps[i]:setTransformOwner()
			steps[i]:suspendedDestroy(70)
		end
		steps[i+2]:suspendedDestroy(1.0)
	end
end

function units_rlauncher_alien_fire()
	local unit = uniGetExecutor()
	wait_for_platform(unit)
	local gt = unit:getBone(ENBT_GUNTOWER)
	unit:play3DSound("bigrocket_alien_prepareforfire.wav",0):destroy()
	unit:addAnimationToQueue(ENAT_PREPAREFORFIRE1,1)
	unit:addAnimationToQueue(ENAT_FIREPOSITION1,MATH_INFINITY)
	pause(1.0)
	local sound = gt:play3DSound("bigrocket_alien_guntower_rotate.wav",1)
	waitDeath(gt:addRotationEffect(ENET_EFFECT_ROTATE_GUNTOWERTOTARGET,MATH_PI,uniGetTarget()))
--	waitDeath(gt:parabolicTargetting(uniGetTarget()))
	sound:stopSound()
	local st_ps = gt:addSimpleEffect(ENET_EFFECT_PS_BIGROCKETFIRE)
	unit:findEffect(ENET_EFFECT_BULLET_BIGROCKETALIENROCKET):executeCommand(ENC_FIRE1)
	pause(0.4)
	st_ps:suspendedDestroy(2.0)
	units_reloadfirespots(uniGetExecutor(),2,ENET_EFFECT_BULLET_BIGROCKETALIENROCKET)
	pause(1.0)
	sound = gt:play3DSound("bigrocket_alien_guntower_rotate.wav",1)
	waitDeath(gt:addRotationEffect(ENET_EFFECT_ROTATE_GUNTOWERDEFAULT,MATH_PI,uniGetTarget()))
	sound:stopSound()
	unit:addAnimationToQueue(ENAT_AFTERFIRE1,1)
	unit:setCurrentAnimationRepeatCount(1)
	unit:play3DSound("bigrocket_alien_prepareforfire.wav",0):destroy()
	unit:addFireArrow()
end

registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_MOVE,"units_rlauncher_alien_move")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_FIRE1,"units_rlauncher_alien_fire")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_FIRE2,"units_rlauncher_alien_fire")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_SELECT,"units_rlauncher_alien_select")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_SELECTENEMY,"units_rlauncher_alien_selectenemy")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_UNSELECT,"units_rlauncher_alien_unselect")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_SETUP,"units_rlauncher_alien_setup")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_RESETUP,"units_rlauncher_alien_resetup")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_DAMAGED,"units_rlauncher_alien_damaged")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_EXPLODE,"units_rlauncher_alien_explode")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_HIGHLIGHT,"units_rlauncher_alien_highlight")
registerCommand(ENSCRIPTSET_BIGROCKET_ALIEN,ENC_INSIDE,"units_inside")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_BIGROCKET_ALIEN)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "bigrocket_alien.rmd"
desc.ScriptSet = ENSCRIPTSET_BIGROCKET_ALIEN
desc.MoveType = ENMOVE_GROUNDORIENTED
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_BIGROCKETALIENSHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "bigrocket_alien_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(16)
unitDesc.group = 0
unitDesc.order = 4
unitDesc.unit_res_id = ENET_UNIT_BIGROCKET_ALIEN
unitDesc.unit_icon_id = "Bigrocket_a_small_normal.dds"
unitDesc.active_id = "Bigrocket_a_small_active.dds"
unitDesc.pressed_id = "Bigrocket_a_small_pressed.dds"
unitDesc.big_icon_id = "Bigrocket_a_big_normal.dds"
unitDesc.small_icon_id = "Bigrocket_l_stats.dds"
unitDesc.HP = 3
unitDesc.MP = 10
unitDesc.WR = 4
unitDesc.min_WR = 2
unitDesc.WD = 3
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 0
unitDesc.transport = 0
unitDesc.value = 4
unitDesc.race = 1
unitDesc.fire_pause = 5.0
unitDesc.move_pause = 0.7
unitDesc.unit_info_scale = 0.06
unitDesc.scn_name = "ARTILLERYA"

------------------------------------------------------------------------------------------------------
------------------------ effects related to unit------------------------------------------------------
------------------------------------------------------------------------------------------------------

function bullets_bigrocketalien_fire()
	local bullet = uniGetExecutor()
	bullet:setTransformOwner()
	bullet:play3DSound("bigrocket_alien_rocket_start.wav",0):destroy()
	waitDeath(bullet:addMoveEffect(ENET_EFFECT_MOVE_ROCKETSTART,130,uniGetTarget(),40.0))
	local light = bullet:addSimpleEffect(ENET_EFFECT_LIGHT_ROCKETENGINE)
--	local sound = bullet:play3DSound("bigrocket_alien_rocket_fly.wav",1)
	bullet:play3DSound("bigrocket_alien_rocket_fly.wav",0)
	local track = bullet:addSimpleEffect(ENET_EFFECT_PS_BIGROCKETENGINE)
	waitDeath(bullet:addMoveEffect(ENET_EFFECT_MOVE_ROCKETFLYPARABOLA,150,uniGetTarget(),7.0))
--	waitDeath(bullet:parabolicFly(uniGetTarget()))
--	sound:destroy()
	light:destroy()
	track:suspendedDestroy(1.0)
	bullet:play3DSound("bigrocket_alien_rocket_explode.wav",0):destroy()
	bullet:setVisibility(false,true)
	bullet:addSimpleEffect(ENET_EFFECT_LIGHT_ROCKETEXPLODE):delayedDestroy(1.0)
	bullet:addSimpleEffect(ENET_EFFECT_PS_BIGROCKETEXPLODE):suspendedDestroy(1.0)
	uniGetTarget():executeCommand(ENC_DAMAGED)
	pause(1.0)
	bullet:destroy()
end

registerCommand(ENSCRIPTSET_BULLET_ALIEN_BIGROCKET,ENC_FIRE1,"bullets_bigrocketalien_fire")
