
function units_seaport_setup()
	building_setup(ENET_GEOMETRY_SEAPORT_SHADOW)
end

function units_seaport_resetup()
	building_setup(ENET_GEOMETRY_SEAPORT_SHADOW)
end

function units_seaport_select()
	units_select(12,1)
end

function units_seaport_unselect()
	units_unselect()
end

function units_seaport_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_seaport_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_seaport_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_seaport_explode()
	units_explode_water1()
end

function units_seaport_move()
end

function units_seaport_fire()
end

registerCommand(ENSCRIPTSET_SEAPORT,ENC_MOVE,"units_seaport_move")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_FIRE1,"units_seaport_fire")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_FIRE2,"units_seaport_fire")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_SELECT,"units_seaport_select")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_SELECTENEMY,"units_seaport_selectenemy")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_UNSELECT,"units_seaport_unselect")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_SETUP,"units_seaport_setup")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_RESETUP,"units_seaport_resetup")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_DAMAGED,"units_seaport_damaged")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_EXPLODE,"units_seaport_explode")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_HIGHLIGHT,"units_seaport_highlight")
registerCommand(ENSCRIPTSET_SEAPORT,ENC_INSIDE,"units_inside")

-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_SEAPORT)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "seaport.rmd"
desc.ScriptSet = ENSCRIPTSET_SEAPORT
desc.MoveType = ENMOVE_SWIM
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_CAPITAL
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_GEOMETRY_SEAPORT_SHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "seaport_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

-- register new unit to logic
unitDesc = logic_getUnitDescP(81)
unitDesc.group = 0
unitDesc.order = 0
unitDesc.unit_res_id = ENET_UNIT_SEAPORT
unitDesc.unit_icon_id = "Smallrobot_h_small_normal.dds"
unitDesc.active_id = "Smallrobot_h_small_active.dds"
unitDesc.pressed_id = "Smallrobot_h_small_pressed.dds"
unitDesc.big_icon_id = "Seaport_ico.dds"
unitDesc.small_icon_id = "Smallrobot_u_stats.dds"
unitDesc.HP = 1000
unitDesc.MP = 10
unitDesc.WR = 1
unitDesc.min_WR = 1
unitDesc.WD = 1
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 3
unitDesc.transport = 0
unitDesc.value = 1
unitDesc.race = 0
unitDesc.fire_pause = 0.2
unitDesc.move_pause = 0.5
unitDesc.unit_info_scale = 0.08
unitDesc.scn_name = "SEAPORT"

------------------------------------------------------------------------------------------------------
------------------------ effects related to unit------------------------------------------------------
------------------------------------------------------------------------------------------------------

