
function units_tank_setup()
	units_setup(5,false,ENET_EFFECT_PS_SETUPSMOKE_SMALL,ENET_EFFECT_GEOMETRY_LIGHTTANKSHADOW)
end

function units_tank_resetup()
	units_setup(5,false,nil,ENET_EFFECT_GEOMETRY_LIGHTTANKSHADOW)
end

function units_tank_select()
	units_select(22,1)
end

function units_tank_unselect()
	units_unselect()
end

function units_tank_selectenemy()
	uniGetExecutor():addSimpleEffect(ENET_EFFECT_SELECTEDGEOMETRY_ENEMY)
end

function units_tank_damaged()
	uniGetExecutor():applyDamage(uniGetLife())
end

function units_tank_highlight()
	uniGetExecutor():addEffectWithRadius(ENET_EFFECT_GEOMETRY_HIGHLIGHT,15)
end

function units_tank_explode()
	units_explode_small3()
end

function units_tank_move()
	local unit = uniGetExecutor()
	local sound = unit:play3DSound("lighttank_move.wav",1)
	local steps = {}
	local i = 0;
	for i = 0,1 do
		steps[i] = unit:getBone(ENBT_STEPEMITTER,i):addSimpleEffect(ENET_EFFECT_DYNAMICGEOMETRY_LIGHTTANKSTEPSEMITTER)
		steps[i+2] = unit:getBone(ENBT_STEPEMITTER,i):addSimpleEffect(ENET_EFFECT_PS_NEWTRACKSMOKE)
	end
	unit:getBone(ENBT_GUNTOWER):addRotationEffect(ENET_EFFECT_ROTATE_GUNTOWERDEFAULT,MATH_PI)
	waitDeath(unit:addRotationEffect(ENET_EFFECT_ROTATE_UNIT,MATH_PI * 1.0))
	waitDeath(unit:addMoveEffect(ENET_EFFECT_MOVE_LINEAR,100))
	sound:destroy()
	unit:play3DSound("lighttank_stop.wav",0):destroy()
	for i = 0,1 do
		if(unit:getScale() < 1.0) then 
			steps[i]:destroy()
		else
			steps[i]:setTransformOwner()
			steps[i]:suspendedDestroy(70)
		end
		steps[i+2]:suspendedDestroy(1.0)
	end
end

function units_tank_fire()
	local unit = uniGetExecutor()
	local gt = unit:getBone(ENBT_GUNTOWER)
	local sound = gt:play3DSound("lighttank_guntower_rotate.wav",1)
	waitDeath(gt:addRotationEffect(ENET_EFFECT_ROTATE_GUNTOWERTOTARGET,MATH_PI,uniGetTarget()))
	sound:stopSound()
	local firespot = gt:getBone(ENBT_FIRE1)
	waitDeath(gt:aimGun(0,MATH_PI / 3.0,uniGetTarget()))
	--firespot:addSimpleEffect(ENET_EFFECT_PS_TANKSHOT):suspendedDestroy(1.0)
	firespot:addSimpleEffect(ENET_EFFECT_PS_NEWTANKSHOT):suspendedDestroy(4.5)
	firespot:addSimpleEffect(ENET_EFFECT_LIGHT_TANKSHOT):delayedDestroy(0.2)
	gt:play3DSound("lighttank_cannon_fire.wav",0):destroy()
	local shot = firespot:addBulletEffect(ENET_EFFECT_BULLET_TANKSHOT)
	shot:executeCommand(ENC_FIRE1)
	gt:gunRecoil(0,0.2,7)
	pause(0.1)

	unit:addFireArrow()
end

registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_MOVE,"units_tank_move")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_FIRE1,"units_tank_fire")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_FIRE2,"units_tank_fire")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_SELECT,"units_tank_select")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_SELECTENEMY,"units_tank_selectenemy")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_UNSELECT,"units_tank_unselect")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_SETUP,"units_tank_setup")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_RESETUP,"units_tank_resetup")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_DAMAGED,"units_tank_damaged")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_EXPLODE,"units_tank_explode")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_HIGHLIGHT,"units_tank_highlight")
registerCommand(ENSCRIPTSET_LIGHTTANK,ENC_INSIDE,"units_inside")


-- make description of unit
desc = getEffectDescriptionP(ENET_UNIT_LIGHTTANK)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "light_tank.rmd"
desc.ScriptSet = ENSCRIPTSET_LIGHTTANK
desc.MoveType = ENMOVE_GROUNDORIENTED
desc.RenderType = ENRENDERTYPE_GEOMETRY
desc.Material = ENMAT_RIGIDSKINNEDMESH
desc.MaterialColors = units_materialcolors_human

-- shadow
desc = getEffectDescriptionP(ENET_EFFECT_GEOMETRY_LIGHTTANKSHADOW)
desc.ClassID = ENCLASS_MESHINSTANCE
desc.EffectClassType = ENECT_GEOMETRY
desc.FileName = "light_tank_shadow.rmd"
desc.RenderType = ENRENDERTYPE_SHADOW
desc.Material = ENMAT_SHADOW
desc.MaterialColors = units_materialcolors_shadow

------------------------------------------------------------------------------------------------------
------------------------ effects related to unit------------------------------------------------------
------------------------------------------------------------------------------------------------------

function bullets_tankshell_fire()
	local bullet = uniGetExecutor()
	bullet:setTransformOwner()
	waitDeath(bullet:addMoveEffect(ENET_EFFECT_MOVE_LINEARFLY,2000,uniGetTarget()),1000)
	bullet:play3DSound("lighttank_cannon_explode.wav",0):destroy()
	local hit_ps = bullet:addSimpleEffect(ENET_EFFECT_PS_TANKSHOTHIT)
	pause(0.2)
	hit_ps:suspendedDestroy(1.0)
	uniGetTarget():executeCommand(ENC_DAMAGED)
	pause(1.0)
	bullet:destroy()
end

registerCommand(ENSCRIPTSET_BULLET_TANKSHOT,ENC_FIRE1,"bullets_tankshell_fire")

-- register new unit to logic
unitDesc = logic_getUnitDescP(2)
unitDesc.group = 0
unitDesc.order = 1
unitDesc.unit_res_id = ENET_UNIT_LIGHTTANK
unitDesc.unit_icon_id = "Tank_h_small_normal.dds"
unitDesc.active_id = "Tank_h_small_active.dds"
unitDesc.pressed_id = "Tank_h_small_pressed.dds"
unitDesc.big_icon_id = "Tank_h_big_normal.dds"
unitDesc.small_icon_id = "Tank_u_stats.dds"
unitDesc.HP = 5
unitDesc.MP = 20
unitDesc.WR = 1
unitDesc.min_WR = 1
unitDesc.WD = 2
unitDesc.WR2 = 0
unitDesc.min_WR2 = 0
unitDesc.WD2 = 0
unitDesc.ability = 1
unitDesc.transport = 0
unitDesc.value = 2
unitDesc.race = 0
unitDesc.fire_pause = 0.6
unitDesc.move_pause = 0.5
unitDesc.unit_info_scale = 0.07
unitDesc.scn_name = "TANK"



